#   Copyright (C) 1987-2004 by Jinlei RUAN
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Last edit by Jinlei on 2007-10-29

import pygame,os,sys,math
from pygame.locals import*
from electro_comp_bipole import*
from py_width_button import*
#matrice =matrice()

class bipoles:
	def __init__(self):
		self.ma =matrice()
	def diode(self,xy=[0,0],ro=0,zoom=20):
		self.di =[[0,2],[1,2],[1,1],[1,3],[1,1],[3,2],[1,3],[3,2],[3,2],[5,2],[3,1],[3,3]]
		return self.cacule(self.di,xy,ro,zoom)
		
	def resitance(self,xy=[0,0],ro=0,zoom=20):
		self.re =[[0,1],[1,1],[1,.5],[1,1.5],[1,.5],[1,1.5],[1,.5],[4,.5],[1,1.5],[4,1.5],[4,.5],[4,1.5],[4,1],[5,1]]
		return self.cacule(self.re,xy,ro,zoom)
		
	def condensateur(self,xy=[0,0],ro=0,zoom=20):
		self.co =[[0,1],[1,1],[1,.5],[1,1.5],[1.5,.5],[1.5,1.5],[1.5,1],[2.5,1]]
		return self.cacule(self.co,xy,ro,zoom)

	def allimentation(self,xy=[0,0],ro=0,zoom=20):
		self.all =[[0,1],[1,1],[1,0],[1,2],[1.75,.75],[1.75,1.30],[1.75,1],[2.75,1]]
		return self.cacule(self.all,xy,ro,zoom)

	def cacule(self,ca0,xy,ro,zoom):
		ro =self.ma.rota(ca0,ro)
		z =self.ma.zoom(ro,zoom)
		p =self.ma.pos_comp(z,xy)
		return p




class commande:
	
	def interrupteur(self,xy=[0,0],ro=0,zoom=0):
		self.ite =[[0,1],[1,1],[3,1],[4,1],[1,5],[3,.5]]
		

class draw_comp:
	def draw(self,root,comp,cl=[0,0,0],wi=1):
		for i in range(0,len(comp),2):
			pos =comp[i:i+2]
			pygame.draw.line(root,cl,pos[0],pos[1],wi)
	def contoure(self,root,comp,dr=1):
		x,y =[],[]
		for i in comp:
			x.append(i[0])
			y.append(i[1])
		x.sort()
		y.sort()
		xy =[x[0]-2,y[0]-2,x[-1]-x[0]+5,y[-1]-y[0]+5]
		if dr==1:pygame.draw.rect(root,[250,0,0],xy,1)
		return xy
		
		

class matrice:
	def zoom(self,comp,zm=20):
		zm5 =[[]]*len(comp)
		for i in range(len(comp)):
			zm5[i] =[comp[i][0]*zm,comp[i][1]*zm]
		return zm5
			
	def rota(self,comp,ro0=90):
		ro5 =[[]]*len(comp)
		cen =[2.5,2]
		ro =math.radians(ro0)
		for i in range(len(comp)):
			c=comp[i][0]
			d=comp[i][1]
			a =(c*math.cos(ro)-d*math.sin(ro))
			b =(c*math.sin(ro)+d*math.cos(ro))
			ro5[i] =[a+cen[0],b+cen[1]]
		return ro5
	def pos_comp(self,comp,pos=[20,20]):
		ps5 =[[]]*len(comp)
		for i in range(len(comp)):
			ps1 =comp[i]
			ps5[i] =[ps1[0]+pos[0],ps1[1]+pos[1]]
		return ps5

	
	def pyta(self,cen,pos):
		r =math.sqrt(math.pow(cen[0]-pos[0],2)+math.pow(cen[1]-pos[1],2))
		return r

if __name__=="__main__":
	
	pygame.init()
	screen =pygame.display.set_mode([300,300])
	screen.fill([250,250,250])
	appz=bipoles()
	d1 =appz.diode([20,20],0,10)
	bt =button(screen,txa=d1)
	bt.draw_rect()
	

	while 1:
		pygame.time.wait(25)
		event =pygame.event.poll()
		mouse =pygame.mouse.get_pos()
		if event.type==QUIT:break
		bt.but_mouse(mouse)
		pygame.display.update()

def old():
	pygame.init()
	screen =pygame.display.set_mode([250,250])
	screen.fill([250,250,250])
	appz =bipoles()
	d1=appz.diode([20,20],0,10)
	draw =draw_comp()
	draw.draw(screen,d1,[250,0,0],2)
	#draw.contoure(screen,d1)	

	re1 =appz.resitance([100,20],0,10)
	draw.draw(screen,re1,[250,0,0],2)
	
	co1 =appz.condensateur([20,100],0,10)
	draw.draw(screen,co1,[250,0,0],2)

	all1 =appz.allimentation([100,100],0,10)
	draw.draw(screen,all1,[250,0,0],2)

	
	while 1:
		pygame.time.wait(25)
		event =pygame.event.poll()
		mouse =pygame.mouse.get_pos()
		if event.type ==QUIT:
			break
		pygame.display.update()
    
	
